﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=6.8
@EndOfDesignText@
#Region Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Dim NumberOfRows As Int					: NumberOfRows = 0
	Dim RowHeight As Int					: RowHeight = 30dip
	Dim RowLineWidth As Int					: RowLineWidth = 1dip
	Dim RowHeight_1 As Int					: RowHeight_1 = RowHeight - RowLineWidth
	Dim RowID As List
	Dim ColLineWidth As Int					: ColLineWidth = 1dip
	Dim ColumnToSort As String				: ColumnToSort = 0		' index of the column to sort
	Dim Filtered As Boolean					: Filtered = False		' flag for the filter function
	Dim FilterType As String				: FilterType = "AND"	' variable for the filter AND / OR
	Dim FilterCriteria As List
	Dim FilterCriteriaID As List
	
	' variables from the Scrollview
	Dim HeaderColor As Int					: HeaderColor = Colors.Blue
	Dim HeaderFontColor As Int			: HeaderFontColor = Colors.RGB(255,255,220)
	Dim HeaderLineColor As Int			: HeaderLineColor = Colors.Yellow
	Dim CellColor As Int						: CellColor = Colors.RGB(255,255,220)
	Dim FontColor As Int						: FontColor = Colors.Black
	Dim FontSize As Float						: FontSize = 14
	Dim Alignment As Int						: Alignment = Gravity.CENTER
	Dim SelectedRow As Int					: SelectedRow = -1
	Dim SelectedID As Int						: SelectedID = -1
	Dim SelectedRowColor As Int			: SelectedRowColor=Colors.RGB(255,196,255)
	Dim SelectedCellColor As Int		: SelectedCellColor=Colors.RGB(255,150,255)
	Type RowCol (Row As Int, Col As Int)
	
	Dim LHeight As Float
	Dim EHeight As Float
	Dim THeight As Float

End Sub

Sub Globals
	Dim scvPersons As ScrollView2D
	Dim pnlToolBox  As Panel
	Dim btnEdit, btnFilter, btnfilterback, DelAll As Button
	Dim pnlHeader As Panel
	Dim cvs As Canvas
	Dim bmp,bmp2,bmp3 As Bitmap
	
	Dim NumberOfColumns = Main.colnumber As Int
	Dim ColumnName()=Main.ColumnName As String
	Dim Columntext()=Main.Columntext As String
	Dim DBTableName As String :	DBTableName = Main.tableview
	Dim ColumnWidth_1(NumberOfColumns) As Int
	Dim TotalColumnWidth(NumberOfColumns + 1) As Int
	Dim SortDirection(NumberOfColumns) As String
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Dim i As Int
	bmp.InitializeMutable(1dip, 1dip)
	bmp2.Initialize(File.DirAssets,"Filter.png")
	bmp3.Initialize(File.DirAssets,"noFilter.png")
	cvs.Initialize2(bmp)
	Activity.LoadLayout("Mainview")
	Activity.Title = Main.qurytitle
	If Activity.Width < Activity.Height Then
		' position pnlToolBox on the bottom of the screen
		pnlToolBox.Top = Activity.Height - pnlToolBox.Height

		scvPersons.Initialize(100, 100, "scvPersons")
		Activity.AddView(scvPersons, 0, RowHeight, 100%x, pnlToolBox.Top - RowHeight)
	Else
		' position pnlToolBox on the bottom of the screen
		pnlToolBox.Left = Activity.Width - pnlToolBox.Width

		scvPersons.Initialize(100, 100, "scvPersons")
		Activity.AddView(scvPersons, 0, RowHeight, Activity.Width - pnlToolBox.Width, Activity.Height - RowHeight)
	End If
	
	' initialze the internal column width and left coordinates
	TotalColumnWidth(0) = ColLineWidth
	For i = 0 To NumberOfColumns - 1
		ColumnWidth_1(i) = Main.ColumnWidth(i) - ColLineWidth+10dip
		TotalColumnWidth(i + 1) = TotalColumnWidth(i) + Main.ColumnWidth(i)+10dip
	Next
	
	' initialize the ScrollView width
	scvPersons.Panel.Width = TotalColumnWidth(NumberOfColumns)
	If RowID.IsInitialized = False Then
		RowID.Initialize
	End If
	
	If FilterCriteria.IsInitialized = False Then
		FilterCriteria.Initialize
		FilterCriteriaID.Initialize
'		For i = 0 To NumberOfColumns - 1
		For i = 0 To 8
			FilterCriteria.Add("ALL")
			FilterCriteriaID.Add(0)
		Next
	End If
	DelAll.Visible=True
End Sub

Sub Activity_Resume
	SelectedRow = -1
	btnEdit.Visible = False
'	btnDelete.Visible = False
	
	' generate the edit panel content
	LHeight = 30dip		' Label height
	EHeight = 50dip		' EditText height
	THeight = LHeight + EHeight + 10dip	' height
	
	SQLTableRead

	If Filtered = True Then
		btnFilter.SetBackgroundImage(bmp3)
	Else
		btnFilter.SetBackgroundImage(bmp2)
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Cell_Click
	Dim rc As RowCol
	Dim l As Label
	
	l = Sender
	rc = l.Tag
	SelectRow(rc)
End Sub

Sub Header_Click
	Dim l As Label
	Dim col As Int
	
	l = Sender
	col = l.Tag

	ColumnToSort = col
	SQLTableRead
End Sub

Sub SelectRow(rc As RowCol)
	Dim col As Int
	'Removes the color of previously selected row
	If SelectedRow > -1 Then
		For col = 0 To NumberOfColumns - 1
			GetView(SelectedRow, col).Color = CellColor
		Next
	End If

	SelectedRow = rc.Row
	SelectedID = GetView(SelectedRow, 0).Text
	'Sets the color of the selected row and selected cell
	For col = 0 To NumberOfColumns - 1
		If col = rc.col Then
			GetView(rc.Row, col).Color = SelectedCellColor
		Else
			GetView(rc.Row, col).Color = SelectedRowColor
		End If
	Next
	
	If SelectedRow > -1 Then
		btnEdit.Visible = True
	Else
		btnEdit.Visible = False
	End If
End Sub

Sub GetView(Row As Int, Col As Int) As Label
	'Returns the label in the specific cell
	Dim l As Label
	l = scvPersons.Panel.GetView(Row * NumberOfColumns + Col)
	Return l
End Sub

Sub AddRow(Values() As String)
	'Adds a row to the table
	If Values.Length <> NumberOfColumns Then
		Return
	End If

	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("cell")
		l.Text = Values(i)
		l.Gravity = Alignment
		l.TextSize = FontSize
		l.TextColor = FontColor
		l.Color = CellColor
		Dim rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = NumberOfRows
		l.Tag = rc
		scvPersons.Panel.AddView(l, TotalColumnWidth(i), RowHeight * NumberOfRows, _
		ColumnWidth_1(i), RowHeight_1)
	Next
	RowID.Add(Values(0))
	NumberOfRows = NumberOfRows + 1
	scvPersons.Panel.Height = NumberOfRows * RowHeight
End Sub

Sub SetHeader(Values() As String)
	'Set the headers values
	If pnlHeader.IsInitialized Then 'should only be called once
		Return
	End If
	
	pnlHeader.Initialize("")
	pnlHeader.Color = HeaderLineColor

	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("Header")
		If SortDirection(i) = "ASC" Then
			l.Text = Values(i) & " ↓"
		Else
			l.Text = Values(i) & " ↑"
		End If
		l.Text = Values(i)
		l.Gravity = Gravity.CENTER
		l.TextSize = FontSize
		l.Color = HeaderColor
		l.TextColor = HeaderFontColor
		l.Tag = i
		pnlHeader.AddView(l, TotalColumnWidth(i), 0, ColumnWidth_1(i), RowHeight_1)
	Next
	Activity.AddView(pnlHeader, scvPersons.Left, 0, TotalColumnWidth(NumberOfColumns), RowHeight)
	pnlToolBox.BringToFront
End Sub


Sub ClearAll
	'Clears the table
	For i = scvPersons.Panel.NumberOfViews -1 To 0 Step -1
		scvPersons.Panel.RemoveViewAt(i)
	Next
	scvPersons.Panel.Height = 0
End Sub

Sub SQLTableRead
	' Reads the SQL data base
	Dim i As Int
	Dim Cursor1 As Cursor
	Dim txt, wtxt As String
	ClearAll
	txt = "SELECT * FROM " & DBTableName

	If Filtered = True Then
		wtxt = ""
		For i = 1 To NumberOfColumns - 1
			Dim fc As String
			fc = FilterCriteria.Get(i)
			If fc <> "ALL" Then
				If wtxt = "" Then
					wtxt = wtxt & ColumnName(i) & " LIKE '" & fc & "'"
				Else
					wtxt = wtxt & " " & FilterType & " " & ColumnName(i) & " LIKE '" & fc & "'"
				End If
			End If
		Next
		
		If Main.filteralert <> "" And wtxt = "" Then
			txt = txt &" WHERE "& Main.filteralert
		Else If Main.filteralert <> "" And wtxt <> "" Then
			txt = txt &" WHERE "& Main.filteralert& " AND "& wtxt
		else If Main.filteralert = "" And wtxt <> "" Then
			txt = txt &" WHERE "& wtxt
		End If
		
	Else
		If Main.filteralert<>"" Then txt=txt&" WHERE "&Main.filteralert
	End If
	
	txt = txt & " ORDER BY " & ColumnName(ColumnToSort) & " " & SortDirection(ColumnToSort)
'	Msgbox(txt,"wtf!")
	Cursor1 = Main.SQL1.ExecQuery(txt)
	Dim Col(NumberOfColumns) As String
	SetHeader(Columntext)
	NumberOfRows = 0
	RowID.Clear
	For i = 0 To Cursor1.RowCount - 1
		Dim Col(NumberOfColumns) As String
		Cursor1.Position = i
		For j = 0 To NumberOfColumns - 1
			Col(j) = Cursor1.GetString(ColumnName(j))
		Next
		AddRow(Col)
	Next
	Cursor1.Close
End Sub

Sub List_Delete(row As Int)
	' Deletes one row
	Dim i, j As Int
	
	Main.SQL1.ExecNonQuery("DELETE FROM "&DBTableName&" WHERE " & _
			ColumnName(0) & " = '" & GetView(row,0).Text & "'")
	
	' updates the texts and tags of the rows above the deletetd row
	For i = row To NumberOfRows - 2
		For j = 0 To NumberOfColumns - 1
			GetView(i,j).Text = GetView(i + 1,j).Text
		Next
	Next
	
	' removes the last row
	For j = NumberOfColumns - 1 To 0 Step -1
		scvPersons.Panel.RemoveViewAt((NumberOfRows - 1) * NumberOfColumns + j)
	Next

	NumberOfRows = NumberOfRows - 1   ' updates the number of rowa
	If NumberOfRows > 0 Then					' updates the ScrollView Panel height
		scvPersons.Panel.Height = NumberOfRows * RowHeight
	Else
		scvPersons.Panel.Height = RowHeight
	End If
End Sub

Sub btnEdit_Click
	StartActivity(Edit)
End Sub

Sub btnFilter_Click
	Filtered = Not(Filtered)
	If Filtered = True Then
		btnFilter.SetBackgroundImage(bmp3)
	Else
		btnFilter.SetBackgroundImage(bmp2)
	End If
	SelectedRow = -1
	btnEdit.Visible = False
	SQLTableRead
End Sub

Sub btnFilter_LongClick
	StartActivity(Filter)
End Sub

Sub scvPersons_ScrollChanged(PosX As Int, PosY As Int)
	pnlHeader.Left = -PosX
End Sub

Sub btnfilterback_click
	Activity.Finish
End Sub

Sub DelAll_click
	If NumberOfRows=0 Then Return
		Dim txt,colname As String
		If DBTableName="trakonesh" Then
			colname="r"
		Else
			colname="id"
		End If
	If SelectedRow=-1 And Msgbox2("Are you sure to del ALL ?","A T T E N T I O N","Yes","","No",Null)=DialogResponse.POSITIVE Then
			txt="DELETE FROM "& DBTableName &" WHERE "&colname&" = (?)"
			For i=0 To NumberOfRows-1
				Main.sql1.ExecNonQuery2(txt,Array As String(GetView(i, 0).Text))
			Next
	Else if SelectedRow<>-1 And Msgbox2("Are you sure to del SELECTED ?","A T T E N T I O N","Yes","","No",Null)=DialogResponse.POSITIVE Then
			txt="DELETE FROM "& DBTableName &" WHERE "&colname&" = (?)"
			Main.sql1.ExecNonQuery2(txt,Array As String(GetView(SelectedRow, 0).Text))
	End If
		ClearAll
		SQLTableRead
		SelectedRow=-1
		btnEdit.Visible=False
End Sub